-- HealthBarPlus v0.46
-- coded 2006 by Slarti on EU-Blackhand 

-- unofficially tweaked 8/18/11 by Worba on Uther to allow pet frames to be created as well

HBP_DisplayedBars={};
HBP_BarWidth=200;
HBP_BarSettings={};
HBP_CastingOn={};
HBP_TimeSinceLastUpdate=0;

HBP_DefaultBarSettings={
	["width"] = 200,
	["height"] = 40,
	["debuffs"] = 1,
	["casts"] = 0,
	["castnames"] = 0,
	["targeting"] = 0,
	["mana"] = 0,
	["ccclick"] = "",
	["ccalt"] = "",
	["ccctrl"] = "",
	["ccshift"] = "",
	["ccaltgr"] = "",
};

function HBP_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("UNIT_SPELLCAST_START");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	SLASH_HBP1 = "/hbp";
	SlashCmdList["HBP"] = HBP_Command;
	hooksecurefunc("RaidFrame_LoadUI", HBP_RaidFrame_LoadUI);
end

function HBP_OnEvent(self, event, ...)
	local arg1 = ...;
	if(event=="ADDON_LOADED" and arg1=="HealthBarPlus") then
		local toDelete={};
		for k,v in pairs(HBP_DisplayedBars) do
			local frame=HBP_AddBar(v.name,true);
			if(frame==nil) then
				table.insert(toDelete,v.name);
			else
				frame:SetPoint("TOPLEFT",UIParent,"TOPLEFT",v.xpos,v.ypos);
			end
		end
		while(table.getn(toDelete)>0) do
			local arraypos=HBP_GetArrayPosForFrameTarget(table.remove(toDelete));
			if(arraypos~=-1) then table.remove(HBP_DisplayedBars,arraypos); end
		end
	end
	if(event=="UNIT_SPELLCAST_START") then
		local showcasts=false;
		for k,v in pairs(HBP_DisplayedBars) do
			if(HBP_BarSettings[v.name].casts==1) then 
				showcasts=true; 
				break;
			end
		end
		if(showcasts==false) then return; end
		local raidid=string.match(arg1,"raid(%d+)");
		local partyid=string.match(arg1,"party(%d+)");
		local raidCount=GetNumRaidMembers();
		local isRaid=true;
		local isSolo=false;
		if(raidCount==0) then
			raidCount=GetNumPartyMembers();
			isRaid=false;
			if(raidCount==0) then
				isSolo=true;
			end
			raidCount=raidCount+1;
		end
		if(raidid or partyid or (arg1=="player" and isRaid==false)) then
			local casttarget=arg1.."target";
			if(UnitIsUnit(arg1,"player")) then
				casttarget="target";
				arg1="player";
			end
			for k=1,raidCount,1 do
				local bartarget;
				if(isRaid==true) then
					bartarget="raid"..k;
				elseif(isSolo==false and k<raidCount) then
					bartarget="party"..k;
				else
					bartarget="player";
				end
				if(UnitIsUnit(casttarget,bartarget)) then
					if(HBP_CastingOn[bartarget]==nil) then HBP_CastingOn[bartarget]={}; end
					local already=false;
					for i, j in pairs(HBP_CastingOn[bartarget]) do
						if(UnitIsUnit(j,arg1)) then 
							already=true; 
							break;
						end
					end
					if(already==false) then table.insert(HBP_CastingOn[bartarget],arg1); end
				end
			end
		end
	end
end

function HBP_SetWidth(width)
	if(width>0 and width<1000) then
		HBP_BarWidth=width;
	end
	for k, v in pairs(HBP_DisplayedBars) do
		local frame=_G["HBP_Bar_"..v.name];
		if(frame) then
			frame:SetWidth(HBP_BarWidth);
			frame.bar:SetWidth(HBP_BarWidth-15);
		end
	end
	HBP_DisplayMessage("HealthBarPlus: Successfully set bar width to "..width.." units!");
end

function HBP_AddBar(targetname, startup)
	if(targetname~="focus" and targetname~="target" and targetname~="player" and targetname~="pet") then
		if(HBP_GetUnitReference(targetname)==nil) then
			HBP_DisplayMessage(HBP_COULDNOTCREATEPART1..targetname..HBP_COULDNOTCREATENOTINRAID);
			return nil;
		end
	end
	for k, v in pairs(HBP_DisplayedBars) do
		if(v.name==targetname and startup==false) then
			HBP_DisplayMessage(HBP_COULDNOTCREATEPART1..targetname..HBP_COULDNOTCREATEALREADYEXISTS);
			return nil;
		end
	end
	if(HBP_BarSettings[targetname]==nil) then HBP_BarSettings[targetname]=HBP_DefaultBarSettings; end
	local frame=HBP_CreateBarFrame(targetname);
	if(startup==false) then table.insert(HBP_DisplayedBars, {name=targetname, xpos=631, ypos=-528}); end
	HBP_DisplayMessage(HBP_CREATEBARSUCCESS..targetname.."'!");
	return frame;
end

function HBP_CreateBarFrame(targetname)
	local frame=_G["HBP_Bar_"..targetname];
	if(frame==nil) then
		frame=CreateFrame("Button", "HBP_Bar_"..targetname, UIParent, "HBPBarTemplate");
	end
	frame:SetWidth(HBP_BarSettings[targetname].width);
	frame:SetPoint("CENTER",0,0);
	frame:EnableMouse(true);
	frame:Show();
	frame.target=targetname;
	frame.bar=_G[frame:GetName().."Bar"];
	frame.bar:SetWidth(HBP_BarSettings[targetname].width-15);
	frame.bar:SetHeight(HBP_BarSettings[targetname].height-14);
	frame.manabar=_G[frame:GetName().."ManaBar"];
	frame.manabar:SetWidth(HBP_BarSettings[targetname].width-15);
	frame.text=_G[frame.bar:GetName().."Text"];
	frame.text:SetText("");
	frame.charname=_G[frame:GetName().."CharNameText"];
	frame.barname=_G[frame:GetName().."BarNameText"];
	frame.targetnames=_G[frame:GetName().."TargetingNamesText"];
	frame.targetnames:SetWidth(HBP_BarSettings[targetname].width);
	frame:SetAttribute("unit", "player");
	frame:SetAttribute("type", "target");
	frame.buff={};
	RegisterUnitWatch(frame);
	for i=1,5,1 do
		frame.buff[i]=_G[frame:GetName().."BuffButton"..i];
		frame.buff[i].icon=_G[frame.buff[i]:GetName().."Icon"];
		frame.buff[i].cooldown=_G[frame.buff[i]:GetName().."Cooldown"];
		frame.buff[i].count=_G[frame.buff[i]:GetName().."Count"];
		frame.buff[i]:Hide();
	end
	frame.cast={};
	for i=1,5,1 do
		frame.cast[i]=_G[frame:GetName().."CastingBar"..i];
		frame.cast[i].bar=_G[frame.cast[i]:GetName().."Bar"];
		frame.cast[i].caster=_G[frame.cast[i]:GetName().."CasterText"];
		frame.cast[i].time=_G[frame.cast[i]:GetName().."TimeText"];
		frame.cast[i].spell=_G[frame.cast[i]:GetName().."SpellText"];
		frame.cast[i].spark=_G[frame.cast[i]:GetName().."BarSpark"];
		frame.cast[i]:Hide();
	end
	return frame;
end

function HBP_ShowConfigWindow(targetname)
	HBPBarConfigFrame.target=targetname;
	if(targetname~="player" and targetname~="target" and targetname~="focus" and targetname~="pet") then
		if(GetNumRaidMembers()>0) then
			HBPBarConfigFrameSubTitleText:SetText("- raid bar: "..targetname.." -");
		else
			HBPBarConfigFrameSubTitleText:SetText("- group bar: "..targetname.." -");
		end
	else 
		HBPBarConfigFrameSubTitleText:SetText("- "..targetname.." bar -");
	end
	HBPBarConfigFrame:Show();
	HBPBarConfigFrame.oldwidth=HBP_BarSettings[targetname].width;
	HBPBarConfigFrame.oldheight=HBP_BarSettings[targetname].height;
	HBPBarConfigFrameBarHeight:SetValue(HBP_BarSettings[targetname].height);
	HBPBarConfigFrameBarWidth:SetValue(HBP_BarSettings[targetname].width);
	HBPBarConfigFrameShowBuffs:SetChecked(HBP_BarSettings[targetname].debuffs);
	HBPBarConfigFrameShowCasts:SetChecked(HBP_BarSettings[targetname].casts);
	HBPBarConfigFrameShowCastNames:SetChecked(HBP_BarSettings[targetname].castnames);
	HBPBarConfigFrameShowTargeting:SetChecked(HBP_BarSettings[targetname].targeting);
	HBPBarConfigFrameShowMana:SetChecked(HBP_BarSettings[targetname].mana);
	HBPBarConfigFrameShowCastNames:SetScale(0.8);
	HBPBarConfigFrameClickCastSpellPlainClick:SetText(HBP_BarSettings[targetname].ccclick);
	HBPBarConfigFrameClickCastSpellAltClick:SetText(HBP_BarSettings[targetname].ccalt);
	HBPBarConfigFrameClickCastSpellCtrlClick:SetText(HBP_BarSettings[targetname].ccctrl);
	HBPBarConfigFrameClickCastSpellShiftClick:SetText(HBP_BarSettings[targetname].ccshift);
	HBPBarConfigFrameClickCastSpellAltgrClick:SetText(HBP_BarSettings[targetname].ccaltgr);
end

function HBP_SaveSettings(self)
	HBP_BarSettings[self:GetParent().target].debuffs=HBPBarConfigFrameShowBuffs:GetChecked();
	HBP_BarSettings[self:GetParent().target].targeting=HBPBarConfigFrameShowTargeting:GetChecked();
	HBP_BarSettings[self:GetParent().target].mana=HBPBarConfigFrameShowMana:GetChecked();
	HBP_BarSettings[self:GetParent().target].casts=HBPBarConfigFrameShowCasts:GetChecked();
	HBP_BarSettings[self:GetParent().target].castnames=HBPBarConfigFrameShowCastNames:GetChecked();
	HBP_BarSettings[self:GetParent().target].ccclick=HBPBarConfigFrameClickCastSpellPlainClick:GetText();
	HBP_BarSettings[self:GetParent().target].ccalt=HBPBarConfigFrameClickCastSpellAltClick:GetText();
	HBP_BarSettings[self:GetParent().target].ccctrl=HBPBarConfigFrameClickCastSpellCtrlClick:GetText();
	HBP_BarSettings[self:GetParent().target].ccshift=HBPBarConfigFrameClickCastSpellShiftClick:GetText();
	HBP_BarSettings[self:GetParent().target].ccaltgr=HBPBarConfigFrameClickCastSpellAltgrClick:GetText();
	_G["HBP_Bar_"..self:GetParent().target].forceUpdate=true;
end

function HBP_RevertSettings(self)
	HBP_BarSettings[self:GetParent().target].height=HBPBarConfigFrame.oldheight;
	HBP_BarSettings[self:GetParent().target].width=HBPBarConfigFrame.oldwidth;
	HBP_RefreshBar(self:GetParent().target);
end

function HBP_RefreshBar(targetname)
	local frame=_G["HBP_Bar_"..targetname];
	if(frame) then
		frame:SetWidth(HBP_BarSettings[targetname].width);
		frame.bar:SetWidth(HBP_BarSettings[targetname].width-15);
		frame.manabar:SetWidth(HBP_BarSettings[targetname].width-15);
		frame:SetHeight(HBP_BarSettings[targetname].height);
		frame.bar:SetHeight(HBP_BarSettings[targetname].height-14);
		frame.targetnames:SetWidth(HBP_BarSettings[targetname].width);
		for i=1,5,1 do
			frame.cast[i]:SetWidth(HBP_BarSettings[targetname].width-30);
			frame.cast[i].bar:SetWidth(HBP_BarSettings[targetname].width-43);
		end
		if(HBP_BarSettings[targetname].height<40) then
			frame.barname:GetParent():Hide();
			frame.charname:GetParent():ClearAllPoints();
			frame.charname:GetParent():SetPoint("TOPRIGHT",frame.charname:GetParent():GetParent(),"TOPLEFT",-6,7-(HBP_BarSettings[targetname].height)/2);
		else
			frame.barname:GetParent():Show();
			frame.barname:GetParent():SetHeight(16);
			frame.charname:GetParent():ClearAllPoints();
			frame.charname:GetParent():SetPoint("TOPRIGHT",frame.barname:GetParent(),"BOTTOMRIGHT",0,-1);
		end
		if(HBP_BarSettings[targetname].height<30) then
			frame.text:SetFontObject("GameFontNormalSmall");
		else
			frame.text:SetFontObject("GameFontNormal");
		end
	end
end

function HBP_UpdateBar(self)
	if(self.target==nil) then return; end
	local targetunit=nil;
	if(self.target~="target" and self.target~="focus" and self.target~="player" and self.target~="pet") then
		targetunit=HBP_GetUnitReference(self.target);
	else
		if(self.target=="player" or UnitExists(self.target)) then 
			targetunit=self.target;
		else
			targetunit=nil;
		end
	end
	if(targetunit==nil) then
		if(self:GetFrameStrata()=="MEDIUM") then
			self:SetAlpha(0.0);
			self:EnableMouse(false);
			self:SetFrameStrata("BACKGROUND");
		end
	else
		if(self:GetFrameStrata()=="BACKGROUND") then
			self:SetAlpha(1.0);
			self:EnableMouse(true);
			self:SetFrameStrata("MEDIUM");
		end
		if(self:GetAttribute("unit")~=targetunit or self.forceUpdate==true) then
			self:SetAttribute("unit", targetunit);
			if(HBP_BarSettings[self.target].ccclick and HBP_BarSettings[self.target].ccclick~="") then
				self:SetAttribute("helpbutton1", "ccclick");
				self:SetAttribute("type-ccclick", "spell");
				self:SetAttribute("spell-ccclick", HBP_BarSettings[self.target].ccclick);
			else
				self:SetAttribute("helpbutton1", "ccclick");
				self:SetAttribute("type-ccclick", "target");
			end
			if(HBP_BarSettings[self.target].ccalt and HBP_BarSettings[self.target].ccalt~="") then
				self:SetAttribute("alt-helpbutton1", "ccalt");
				self:SetAttribute("alt-type-ccalt", "spell");
				self:SetAttribute("alt-spell-ccalt", HBP_BarSettings[self.target].ccalt);
			else
				self:SetAttribute("alt-helpbutton1", "ccalt");
				self:SetAttribute("alt-type-ccalt", "target");
			end
			if(HBP_BarSettings[self.target].ccctrl and HBP_BarSettings[self.target].ccctrl~="") then
				self:SetAttribute("ctrl-helpbutton1", "ccctrl");
				self:SetAttribute("ctrl-type-ccctrl", "spell");
				self:SetAttribute("ctrl-spell-ccctrl", HBP_BarSettings[self.target].ccctrl);
			else
				self:SetAttribute("ctrl-helpbutton1", "ccctrl");
				self:SetAttribute("ctrl-type-ccctrl", "target");
			end
			if(HBP_BarSettings[self.target].ccshift and HBP_BarSettings[self.target].ccshift~="") then
				self:SetAttribute("shift-helpbutton1", "ccshift");
				self:SetAttribute("shift-type-ccshift", "spell");
				self:SetAttribute("shift-spell-ccshift", HBP_BarSettings[self.target].ccshift);
			else
				self:SetAttribute("shift-helpbutton1", "ccshift");
				self:SetAttribute("shift-type-ccshift", "target");
			end
			if(HBP_BarSettings[self.target].ccaltgr and HBP_BarSettings[self.target].ccaltgr~="") then
				self:SetAttribute("alt-ctrl-helpbutton1", "altgr");
				self:SetAttribute("alt-ctrl-type-altgr", "spell");
				self:SetAttribute("alt-ctrl-spell-altgr", HBP_BarSettings[self.target].ccaltgr);
			else
				self:SetAttribute("alt-ctrl-helpbutton1", "altgr");
				self:SetAttribute("alt-ctrl-type-altgr", "target");
			end
			self.forceUpdate=false;
		end
		local unithealth=UnitHealth(targetunit);
		local unithealthmax=UnitHealthMax(targetunit);
		self.bar:SetMinMaxValues(0,unithealthmax);
		self.bar:SetValue(unithealth);	
		self.bar:SetStatusBarColor(HBP_GetBarColor(unithealth, unithealthmax));
		if(HBP_BarSettings[self.target].mana) then
			local unitmana=UnitMana(targetunit);
			local unitmanamax=UnitManaMax(targetunit);
			local unitpowertype=UnitPowerType(targetunit);
			self.manabar:SetMinMaxValues(0,unitmanamax);
			self.manabar:SetValue(unitmana);
			self.manabar:Show();
			if(unitpowertype==0) then
				self.manabar:SetStatusBarColor(0.2, 0.2, 1.0);
			elseif(unitpowertype==1) then
				self.manabar:SetStatusBarColor(1.0, 0, 0);
			else
				self.manabar:SetStatusBarColor(1.0, 1.0, 0);
			end
		else
			self.manabar:Hide();
		end
		if(UnitIsDead(targetunit)) then
			self.text:SetText("dead");
		elseif(UnitIsGhost(targetunit)) then
			self.text:SetText("ghost");
		elseif(UnitIsConnected(targetunit)==nil) then
			self.text:SetText("offline");
			self.bar:SetValue(0);
		else
			if(UnitIsFriend(targetunit, "player")) then
				self.text:SetText(0-(unithealthmax-unithealth));
			else
				self.text:SetText(unithealth);
			end
			if(self.text:GetText()=="0") then
				self.text:SetText("");
			end
		end
		self.charname:SetText(UnitName(targetunit));
		if(self.target=="focus") then
			self.barname:SetText("Focus:");
		elseif(self.target=="target") then
			self.barname:SetText("Target:");
		elseif(self.target=="player") then
			self.barname:SetText("Player:");
		elseif(self.target=="pet") then
			self.barname:SetText("Pet:");
		else
			if(GetNumRaidMembers()>0) then
				self.barname:SetText("Raid:");
			else
				self.barname:SetText("Group:");
			end
		end
		local buffid=1;
		local buffName,buffRank,buffTexture,buffApplications,buffType,buffDuration,buffTimeLeft,isMine;
		for i=1,5,1 do
			if(UnitIsFriend(targetunit, "player")) then
				repeat
					buffName,buffRank,buffTexture,buffApplications,buffType,buffDuration,buffTimeLeft,caster=UnitBuff(targetunit, buffid);
					buffid=buffid+1;
				until(caster=="player" or buffName==nil);
			else
				repeat
					buffName,buffRank,buffTexture,buffApplications,buffType,buffDuration,buffTimeLeft,caster=UnitDebuff(targetunit, buffid);
					buffid=buffid+1;
				until(caster=="player" or buffName==nil);
			end
			if(buffName~=nil and HBP_BarSettings[self.target].debuffs) then
				self.buff[i]:Show();
				self.buff[i].icon:SetTexture(buffTexture);
				if(buffDuration>0) then
					self.buff[i].cooldown:Show();
					startCooldownTime = buffTimeLeft-buffDuration;
					CooldownFrame_SetTimer(self.buff[i].cooldown, startCooldownTime, buffDuration, 1);
				else
					self.buff[i].cooldown:Hide();
				end
				if(buffApplications>1) then
					self.buff[i].count:SetText(buffApplications);
					self.buff[i].count:Show();
				else
					self.buff[i].count:Hide();
				end
			else
				self.buff[i]:Hide();
			end
		end
	end
	
end

function HBP_OnUpdate(self, elapsed)
	HBP_TimeSinceLastUpdate=HBP_TimeSinceLastUpdate+elapsed;
	if(HBP_TimeSinceLastUpdate>0.04) then
		HBP_ScanTargets();
		HBP_TimeSinceLastUpdate=0;
	end
end

function HBP_SavePosition(self)
	local point,relativeTo,relativePoint,xOffset,yOffset=self:GetPoint();
	local arraypos=HBP_GetArrayPosForFrameTarget(self.target);
	if(arraypos~=-1) then 
		HBP_DisplayedBars[arraypos].xpos=xOffset;
		HBP_DisplayedBars[arraypos].ypos=yOffset;
	end
end

function HBP_ResetPos()
	for k,v in pairs(HBP_DisplayedBars) do
		v.xpos=0;
		v.ypos=0;
		local frame=_G["HBP_Bar_"..v.name];
		if(frame~=nil) then
			frame:ClearAllPoints();
			frame:SetPoint("CENTER",0,0);
		end
	end
	HBP_DisplayMessage(HBP_POSITIONRESETCOMPLETE);
end

function HBP_GetBarColor(health, healthmax)
	local r,g;
	if(healthmax/2>=health) then
		r=1.0;
		g=1.0-(((healthmax/2)-health)/(healthmax/2));
	else
		g=1.0;
		r=1.0-((health-(healthmax/2))/(healthmax/2));
	end
	return r,g,0.0,1.0;
end

function HBP_GetUnitReference(charname)
	if(charname=="player" or charname=="focus" or charname=="target" or charname=="pet") then return charname; end
	for i=1,GetNumRaidMembers(),1 do
		if(UnitName("raid"..i)==charname) then
			return "raid"..i;
		end
		if(UnitName("raidpet"..i)==charname) then
			return "raidpet"..i;
		end
	end
	for i=1,GetNumPartyMembers(),1 do
		if(UnitName("party"..i)==charname) then
			return "party"..i;
		end
		if(UnitName("partypet"..i)==charname) then
			return "partypet"..i;
		end
	end
	return nil;	
end

function HBP_DeleteBar() 
	local arraypos=HBP_GetArrayPosForFrameTarget(self.target);
	if(arraypos~=-1) then table.remove(HBP_DisplayedBars,arraypos); end
	UnregisterUnitWatch(self);
	self:Hide();
	self:EnableMouse(false);
	self.target=nil;
end

function HBP_GetArrayPosForFrameTarget(frametarget)
	for i=1,table.getn(HBP_DisplayedBars),1 do
		if(HBP_DisplayedBars[i].name==frametarget) then
			return i;
		end
	end
	return -1;
end

function HBP_Command(cmd)
	parts={};
	partcount=0;
	for w in string.gmatch(cmd, "%S+") do
    		parts[partcount]=w;
	    	partcount=partcount+1;
	end
	if(partcount==0) then
		HBP_DisplayMessage(HBP_COMMANDS1);
		HBP_DisplayMessage(HBP_COMMANDS2);
		HBP_DisplayMessage(HBP_COMMANDS3);
		HBP_DisplayMessage(HBP_COMMANDS4);
    		return;
	end
	if(partcount==1) then
		if(parts[0]=="resetpos") then
			HBP_ResetPos();
		end
		return;
	end
	if(partcount==2) then
		if(parts[0]=="addbar") then
			HBP_AddBar(parts[1],false);
		end
		if(parts[0]=="setwidth") then
			HBP_SetWidth(tonumber(parts[1]));
		end
		return;
	end
end

Original_RaidPulloutButton_OnDragStart=nil;

function HBP_HookRaidWindow()
	Original_RaidPulloutButton_OnDragStart=RaidPulloutButton_OnDragStart;
	RaidPulloutButton_OnDragStart=HBP_RaidPulloutButton_OnDragStart;
end

function HBP_RaidFrame_LoadUI()
	if(Original_RaidPulloutButton_OnDragStart==nil) then
		HBP_HookRaidWindow();
	end
end

function HBP_RaidPulloutButton_OnDragStart(frame)
	if(IsControlKeyDown() and IsShiftKeyDown()) then
		HBP_AddBar(this.name,false);
		frame:Hide();
	else
		Original_RaidPulloutButton_OnDragStart(frame);
	end
end

function HBP_DisplayMessage(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function HBP_ScanTargets()
	if(table.getn(HBP_DisplayedBars)==0) then return; end
	local raidCount=GetNumRaidMembers();
	local isRaid=true;
	local isSolo=false;
	if(raidCount==0) then
		raidCount=GetNumPartyMembers();
		isRaid=false;
		if(raidCount==0) then
			isSolo=true;
		end
		raidCount=raidCount+1;
	end
	local bartargets={};
	local i,k;
	for i=1, table.getn(HBP_DisplayedBars), 1 do
		local bartarget=HBP_DisplayedBars[i].name;
		if(bartarget~="player" and bartarget~="target" and bartarget~="focus" and bartarget~="pet") then
			bartarget=HBP_GetUnitReference(bartarget);
		end
		if(bartarget~=nil) then
			table.insert(bartargets,{target=bartarget, name=HBP_DisplayedBars[i].name});
		end
	end
	local currenttime=GetTime()*1000;
	for i=1, table.getn(bartargets), 1 do
		local castlist={};
		if(HBP_BarSettings[bartargets[i].name].casts==1) then
			if(UnitIsFriend("player",bartargets[i].target)) then
				local castingon=nil;
				for k,v in pairs(HBP_CastingOn) do
					if(UnitIsUnit(k,bartargets[i].target)) then
						castingon=HBP_CastingOn[k];
						break;
					end
				end
				if(castingon) then
					for k=table.getn(castingon), 1, -1 do
						local uid=castingon[k];
						local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(uid);
						if(spell) then
							local timeleft=endTime-currenttime;
							if(timeleft<0) then timeleft=0; end
							table.insert(castlist,{id=uid,cs=startTime,ce=endTime,left=timeleft,sp=displayName.." ("..rank..")"});
						else
							table.remove(castingon,k);
						end
					end
				end
			elseif(UnitIsEnemy("player",bartargets[i].target)) then
				for k=1, raidCount, 1 do
					local uid;
					if(isRaid==true) then
						uid="raid"..k;
					elseif(isSolo==false and k<raidCount) then
						uid="party"..k;
					else
						uid="player";
					end
					local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(uid);
					if(spell) then
						if(UnitIsUnit(uid.."target",bartargets[i].target)) then
							local timeleft=endTime-currenttime;
							if(timeleft<0) then timeleft=0; end
							table.insert(castlist,{id=uid,cs=startTime,ce=endTime,left=timeleft,sp=displayName.." ("..rank..")"});
						end
					end
				end
			end
			table.sort(castlist,HBP_SortCastListComparison);
		end
		local barframe=_G["HBP_Bar_"..bartargets[i].name];
		for k=1, 5, 1 do
			if(castlist[k] and barframe) then
				local bar=barframe.cast[k];
				local barBar=bar.bar;
				local barCaster=bar.caster;
				local barTime=bar.time;
				local barSpell=bar.spell;
				local barSpark=bar.spark;
				local barMaxValue=castlist[k].ce-castlist[k].cs;
				barBar:SetMinMaxValues(0,barMaxValue);
				barBar:SetValue(barMaxValue-castlist[k].left);
				if(UnitIsUnit(castlist[k].id,"player")) then
					barBar:SetStatusBarColor(1,0,0,1);
				else
					barBar:SetStatusBarColor(1,1,1,1);
				end
				barSpark:ClearAllPoints();
				barSpark:SetPoint("CENTER", barBar, "LEFT", (barBar:GetValue()/barMaxValue)*barBar:GetWidth(), 0);
				barCaster:SetText(UnitName(castlist[k].id));
				barTime:SetText(string.format('%3.1f',(math.floor(castlist[k].left/100)/10)));
				barSpell:SetText(castlist[k].sp);
				if(HBP_BarSettings[bartargets[i].name].castnames==1) then
					barSpell:Show();
				else
					barSpell:Hide();
				end
				bar:Show();
			else
				if(barframe) then
					local bar=barframe.cast[k];
					bar:Hide();
				end
			end
		end
		if(HBP_BarSettings[bartargets[i].name].targeting==1) then
			local targetstring=nil;
			for k=1, raidCount, 1 do
				local uid;
				if(isRaid==true) then
					uid="raid"..k;
				elseif(isSolo==false and k<raidCount) then
					uid="party"..k;
				else
					uid="player";
				end
				if(UnitIsUnit(uid.."target",bartargets[i].target) and (bartargets[i].target~="target" or not UnitIsUnit(uid,"player"))) then
					local _, englishClass = UnitClass(uid);
					if(englishClass) then
						local r,g,b = HBP_GetColorForClass(englishClass);
						local hexstring=HBP_RGBToHex(r,g,b);
						if(targetstring==nil) then
							targetstring="|cFF"..hexstring..UnitName(uid).."|r";
						else
							targetstring=targetstring.."|cFF"..hexstring..", "..UnitName(uid).."|r";
						end
					end
				end
			end
			if(targetstring~=nil) then
				barframe.targetnames:SetText(targetstring);
				barframe.targetnames:Show();
			else
				barframe.targetnames:Hide();
			end
		else
			barframe.targetnames:Hide();
		end
	end
end

function HBP_SortCastListComparison(a,b)
	if(a.left<b.left) then return true; end
	return false;
end

function HBP_GetColorForClass(class)
	if(class=="DRUID") then return 1.0, 0.49, 0.04; end
	if(class=="HUNTER") then return 0.67, 0.83, 0.45; end
	if(class=="MAGE") then return 0.41, 0.8, 0.94; end
	if(class=="PALADIN") then return 0.96, 0.55, 0.73; end
	if(class=="PRIEST") then return 1.0, 1.0, 1.0; end
	if(class=="ROGUE") then return 1.0, 0.96, 0.41; end
	if(class=="SHAMAN") then return 0.96, 0.55, 0.73; end
	if(class=="WARLOCK") then return 0.58, 0.51, 0.79; end
	if(class=="WARRIOR") then return 0.78, 0.61, 0.43; end
	if(class=="DEATHKNIGHT" or class=="DEATH KNIGHT") then return 0.78, 0.61, 0.43; end
end

function HBP_RGBToHex(r, g, b)
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end